package com.book.push.config;

import com.book.push.service.wx.WxThirdPartService;
import com.book.push.utils.JsonUtils;
import com.book.push.utils.Md5Util;
import com.book.push.vo.AuthorizerInfo;
import com.book.push.vo.ComponentInfo;
import lombok.NonNull;
import me.chanjar.weixin.open.api.impl.WxOpenInRedisConfigStorage;
import redis.clients.jedis.Jedis;
import redis.clients.jedis.util.Pool;

/**
 * created in 2021/8/25
 * Project: book-store
 *
 * @author win7
 */

public class WxOpenInRedisBookConfigStorage extends WxOpenInRedisConfigStorage {


    public WxOpenInRedisBookConfigStorage(@NonNull Pool<Jedis> jedisPool, String keyPrefix) {
        super(jedisPool, keyPrefix);
    }

    public String getVerifyTicketCacheKey(String appid) {
        return WxThirdPartService.VERIFY_TICKET_KEY_PREFIX + appid;
    }

    public String getVerifyTicketCacheKey() {
        if (this.getComponentAppId() == null) {
            System.out.println("getVerifyTicketCacheKey is null,please set component appid");
            throw new NullPointerException("ComponentAppId is null,please set component appid");
        }
        return WxThirdPartService.VERIFY_TICKET_KEY_PREFIX + this.getComponentAppId();
    }

    public String getComponentTokenCacheKey(ComponentInfo componentInfo) {

        return WxThirdPartService.TOKEN_KEY_PREFIX + Md5Util.md5(JsonUtils.toJsonString(componentInfo));
    }

    public String getComponentTokenCacheKey() {
        if (this.getComponentAppId() == null || this.getComponentAppSecret() == null || this.getComponentVerifyTicket() == null) {
            throw new NullPointerException("ComponentAppId , ComponentAppSecret and ComponentVerifyTicket " +
                    "must be not null,please set component appid");
        }
        ComponentInfo componentInfo = new ComponentInfo(getComponentAppId(), getComponentAppSecret(), getComponentVerifyTicket());
        return WxThirdPartService.TOKEN_KEY_PREFIX + Md5Util.md5(JsonUtils.toJsonString(componentInfo));
    }


    public String getAuthorizerTokenCacheKey(AuthorizerInfo authorizerInfo) {

        return WxThirdPartService.TOKEN_KEY_PREFIX + Md5Util.md5(JsonUtils.toJsonString(authorizerInfo));
    }


}
